var theInterval = 60; // number of minutes to wait between updates
var wasUpdated = false;
var lastUpdate = new Date();
var itemList = new Array();
itemList[0] = resetItem();
var itemCount = 0;
var displayedItem = 0;
var theUrl = 'https://store.apple.com/';

var theMonths = new Array();
theMonths[0] = 'Jan';
theMonths[1] = 'Feb';
theMonths[2] = 'Mar';
theMonths[3] = 'Apr';
theMonths[4] = 'May';
theMonths[5] = 'Jun';
theMonths[6] = 'Jul';
theMonths[7] = 'Aug';
theMonths[8] = 'Sep';
theMonths[9] = 'Oct';
theMonths[10] = 'Nov';
theMonths[11] = 'Dec';

function setup () {

	createGenericButton(doneButton,'Done',hidePrefs,50);
	if (window.widget) {
		orderno.value = (widget.preferenceForKey('orderno'+widget.identifier)) ? 
			widget.preferenceForKey('orderno'+widget.identifier) : '';
		zipcode.value = (widget.preferenceForKey('zipcode'+widget.identifier)) ? 
			widget.preferenceForKey('zipcode'+widget.identifier) : '';
		updateevery.value = (widget.preferenceForKey('updateevery'+widget.identifier)) ? 
			widget.preferenceForKey('updateevery'+widget.identifier) : '60';
		widgetsize.value = (widget.preferenceForKey('widgetsize'+widget.identifier)) ? 
			widget.preferenceForKey('widgetsize'+widget.identifier) : 'small';
	}
	toggleSize();
	if (updateevery.value) theInterval = parseInt(updateevery.value);
	if (orderno.value && zipcode.value) {
		updateStatus(true);
	} else showPrefs();
	if (window.widget) widget.onshow = updateStatus;

}

function resetItemList () {

	itemList = new Array();
	itemList[0] = resetItem();
	displayedItem = 0;

}

function resetItem () {

	var thisItem = new Array();
	thisItem['theItem'] = 'Item Not Found';
	thisItem['shipSaved'] = '';
	thisItem['shipDate'] = '<span class="small">Shipped by </span>Unknown';
	thisItem['shipDays'] = '<span class="small">Shipped by </span>Unknown';
	thisItem['deliverySaved'] = '';
	thisItem['deliveryDate'] = '<span class="small">Delivered by </span>Unknown';
	thisItem['deliveryDays'] = '<span class="small">Delivered by </span>Unknown';
	thisItem['daysNumber'] = -1;
	thisItem['daysText'] = false;
	return thisItem;

}

function loadPage (theUrl,theFunction) {

	xmlRequest = new XMLHttpRequest();
	xmlRequest.onload = theFunction;
	xmlRequest.open('GET',theUrl);
	xmlRequest.send();

}

function updateStatus (forceUpdate) {

	var rightNow = new Date();
	var nextUpdate = new Date(lastUpdate);
	nextUpdate.setTime(nextUpdate.getTime()+(theInterval * 60000));

	if (forceUpdate == true || rightNow > nextUpdate) {
		showMessage('theMessage','Contacting Apple Store&hellip;<span class="large">&nbsp;</span>');
		loadPage('https://store.apple.com/Your/WebObjects/OrderStatus.woa/-/FindOrderPage.wo',getSession);
	}

}

function getSession () {

	if (xmlRequest.status == 200) {
		if (xmlRequest.responseText) {

			var theOutput = xmlRequest.responseText;
			if (theOutput) theOutput = theOutput.match(/<form method=post action="(.*)">/i);
				if (theOutput && theOutput[1]) {
				
					theUrl = theOutput[1]+'?0.19.1.0.8.25.0.1.1='+escape(orderno.value)+
						'&0.19.1.0.8.25.0.1.5='+escape(zipcode.value);
					document.getElementById('apple').href = theUrl;
				
					showMessage('theMessage','Getting order status&hellip;<span class="large">&nbsp;</span>');
					loadPage(theUrl,processPage);
		
				} else showMessage('theMessage','<a href="javascript:updateStatus(true)">Couldn\'t connect <span class="large">&#8617;</span></a>');

		} else showMessage('theMessage','<a href="javascript:updateStatus(true)">Couldn\'t connect <span class="large">&#8617;</span></a>');
	} else showMessage('theMessage','<a href="javascript:updateStatus(true)">Couldn\'t connect <span class="large">&#8617;</span></a>');

	return;
}

function processPage () {

	var theSections = false;
	var theItems = false;
	var theResult = false;
	var thisResult = false;
	var x = 0;
	var y = 0;
	var z = 0;

	if (xmlRequest.status == 200) {
		if (xmlRequest.responseText) {
		
			// remove extra white space
			theOutput = xmlRequest.responseText.replace(/\s+/g,' ');

			// get each section of the order
			theSections = theOutput.match(/<div class="rightHeader"> ?<div class="headerTextwhite"> ([^<]*) <\/div> <\/div> ?<div class="rightSubheader"> ?(<\/div> ?<div class="infoRight"> ?)?<table([^>]*)>(.*?)<div align="right"> ?<\/div> ?<\/td> ?<\/tr> ?<\/table> ?<\/div>/gi);

			for (y in theSections) {

				var theStatus = false;
				var sectionShipped = false;
				var trackingUrl = false;

				// get the status of this section: not yet shipped, shipped, or complete
				theResult = theSections[y].match(/<div class="headerTextwhite"> ([^<]*) <\/div>/i);
				if (theResult && theResult[1]) theStatus = theResult[1];

				if (theStatus == 'Shipped') {
					// get the ship date for shipped items
					theResult = theSections[y].match(/Shipped on <strong> (.*?) <\/strong> via/i);
					if (theResult && theResult[1]) sectionShipped = theResult[1];

					// get the tracking number for shipped items
					theResult = theSections[y].match(/<a target="carrierpage" href="([^"]*)"> Track this shipment <\/a>/i);
					if (theResult && theResult[1]) trackingUrl = theResult[1];					
				}
		
				// get each item in the section
				theItems = theSections[y].match(/<tr> ?<td width="25" class="data">(.*?)<\/td> ?<\/tr>/gi);
				for (z in theItems) {
		
					var thisItem = resetItem();
					thisItem['theStatus'] = theStatus;
					thisItem['trackingUrl'] = trackingUrl;
		
					// get the name of the item
					theResult = theItems[z].match(/<td width="180" class="data"> ?<div class=""> ([^<]*)<br>/i);
					if (theResult && theResult[1]) {
						thisItem['theItem'] = theResult[1];
				
						// get the ship and delivery dates
						theResult = theItems[z].match(/<td width="75" class="data"> ?<div align="left">([^<]*)/ig);
						if (sectionShipped) {
							thisItem['shipSaved'] = sectionShipped;
						} else {
							if (theResult && theResult[0]) {
								thisResult = theResult[0].match(/<td width="75" class="data"> ?<div align="left">([^<]*)/i);
								if (thisResult) thisItem['shipSaved'] = thisResult[1];
							}
						}
						if (theResult && theResult[1]) {
							thisResult = theResult[1].match(/<td width="75" class="data"> ?<div align="left">([^<]*)/i);
							if (thisResult) thisItem['deliverySaved'] = thisResult[1];
						}
			
						itemList[x] = thisItem;
						x++;
					}
		
				}
			}

			itemCount = itemList.length;
	
			// get the current date
			wasUpdated = true;
			lastUpdate = new Date();

			var theHours = lastUpdate.getHours();
			var theMinutes = lastUpdate.getMinutes();
			var theAMPM = 'AM';
			if (theMinutes < 10) theMinutes = '0' + theMinutes;
			if (theHours > 11) {
				if (theHours > 12) theHours = theHours - 12;
				theAMPM = 'PM';
			} else if (theHours == 0) {
				theHours = 12;
			}
			updateTime = theMonths[lastUpdate.getMonth()]+' '+lastUpdate.getDate()+', '+
				theHours+':'+theMinutes+theAMPM;
		
			showMessage('theMessage','<a href="javascript:updateStatus(true)">Updated '+
				updateTime+' <span class="large">&#8617;</span></a>');

		} else showMessage('theMessage','<a href="javascript:updateStatus(true)">Couldn\'t connect <span class="large">&#8617;</span></a>');
	} else showMessage('theMessage','<a href="javascript:updateStatus(true)">Couldn\'t connect <span class="large">&#8617;</span></a>');

	updateItems();
	displayItem(displayedItem);

	return;

}

function updateItems () {

	var x;
	for (x in itemList) {
	
		var thisItem = itemList[x];
		var theResult = false;

		// update the display
		if (thisItem['shipSaved']) {
			theResult = parseDate(thisItem['shipSaved'],thisItem['theStatus'],
				thisItem['trackingUrl'],'Shipped');
			thisItem['shipDate'] = theResult[0];
			thisItem['shipDays'] = theResult[1];
			thisItem['daysNumber'] = theResult[2];
			thisItem['daysText'] = theResult[3];
		}
		if (thisItem['deliverySaved']) {
			theResult = parseDate(thisItem['deliverySaved'],thisItem['theStatus'],
				thisItem['trackingUrl'],'Delivered');
			thisItem['deliveryDate'] = theResult[0];
			thisItem['deliveryDays'] = theResult[1];
			if (theResult[2] >= 0) {
				thisItem['daysNumber'] = theResult[2];
				thisItem['daysText'] = theResult[3];
			}
		}
	
		// force it to display the "shipped!" or "delivered!" message when appropriate
		if (displayedItem == x && thisItem['shipDate'] == 'Shipped!' && 
			document.getElementById('shipDate').innerHTML != 'Shipped!' && 
			document.getElementById('shipDate').style.display == 'none') 
			toggleView('shipDays','shipDate');
	
		if (displayedItem == x && thisItem['deliveryDate'] == 'Delivered!' && 
			document.getElementById('deliveryDate').innerHTML != 'Delivered!' && 
			document.getElementById('deliveryDate').style.display == 'none') 
			toggleView('deliveryDays','deliveryDate');

		itemList[x] = thisItem;

	}

}

function displayItem (x) {

	var thisItem = itemList[x];
	displayedItem = x;

	if (itemCount > 1) {
		var nextItem = x + 1;
		if (nextItem > itemCount - 1) nextItem = 0;
		showMessage('theItem','<a href="javascript:displayItem('+nextItem+')">'+thisItem['theItem']+'</a>');
	} else showMessage('theItem',thisItem['theItem']);
	document.getElementById('theItem').title = thisItem['theItem'];

	showMessage('shipDate',thisItem['shipDate']);
	showMessage('shipDays',thisItem['shipDays']);
	showMessage('deliveryDate',thisItem['deliveryDate']);
	showMessage('deliveryDays',thisItem['deliveryDays']);

	if (thisItem['daysNumber'] > 0) {
		if (thisItem['daysNumber'] > 999) {
			showMessage('daysNumber','999+');
			showMessage('daysText',thisItem['daysText']);
			document.getElementById('days').className = 'many';
		} else if (thisItem['daysNumber'] > 99) {
			showMessage('daysNumber',thisItem['daysNumber']);
			showMessage('daysText',thisItem['daysText']);
			document.getElementById('days').className = 'small';
		} else if (thisItem['daysNumber'] < 20) {
			showMessage('daysNumber',thisItem['daysNumber']);
			showMessage('daysText',thisItem['daysText']);
			document.getElementById('days').className = 'compress';
		} else {
			showMessage('daysNumber',thisItem['daysNumber']);
			showMessage('daysText',thisItem['daysText']);
			document.getElementById('days').className = '';
		}
		document.getElementById('info').className = 'daysOn';
		document.getElementById('days').style.display = 'block';
	} else {
		document.getElementById('days').style.display = 'none';
		document.getElementById('info').className = '';
	}

	document.getElementById('hideMe').style.display = 'block';

	return false;

}

function parseDate (theInput,theStatus,trackingUrl,theType) {

	var theOutput = new Array();
	theOutput[0] = '<span class="small">'+theType+' by </span>Unknown';
	theOutput[1] = '<span class="small">'+theType+' by </span>Unknown';
	theOutput[2] = -1;
	theOutput[3] = false;

	if (theStatus == 'Shipped' && theType == 'Delivered') {
		if (trackingUrl) theOutput[0] = theOutput[1] = '<a href="'+trackingUrl+
			'" onclick="return openSite(this.href)">Track this shipment</a>';
	} else if (theStatus == 'Complete') {
		theOutput[0] = theType+'!';
		theOutput[1] = theType+'!';
		theOutput[2] = -1;
		theOutput[3] = 'days';
	} else {

		if (theInput && theInput != ' &nbsp; ') {
			var endDate = new Date(theInput);
			if (new String(endDate.getDate()) != 'NaN') {
				var rightNow = new Date();
				if (rightNow < endDate) {
					var daysApart = Math.floor(((endDate-rightNow)/86400000)+1);
	
					if (daysApart == 1) {
						theOutput[3] = 'day';
					} else theOutput[3] = 'days';
	
					theOutput[0] = '<span class="small">'+theType+' by </span>'+
						theMonths[endDate.getMonth()]+' '+endDate.getDate();
					theOutput[1] = '<span class="small">'+theType+' in</span> '+
						daysApart+' '+theOutput[3];
					theOutput[2] = daysApart;
	
				} else {
					theOutput[0] = theType+'!';
					theOutput[1] = '<span class="small">'+theType+' on</span> '+
						theMonths[endDate.getMonth()]+' '+endDate.getDate();
					theOutput[2] = 0;
					theOutput[3] = 'days';
				}
			} else theOutput[0] = theOutput[1] = '<span class="small">'+theType+' in </span>'+theInput;
		}

	}
	return theOutput;

}

function showMessage (theId,theString) {
	document.getElementById(theId).innerHTML = theString;
}

function toggleView (hideId,showId) {
	document.getElementById(hideId).style.display = 'none';
	document.getElementById(showId).style.display = 'block';
}

function toggleSize () {
	if (widgetsize.value == 'large') {
		document.getElementById('background').src = 'Default-Large.png';
		document.getElementById('edge').src = 'Edge-Large.png';
		document.getElementById('backBackground').src = 'Back-Large.png';
		document.body.className = 'large';
		window.resizeTo(320,117);
	} else {
		document.getElementById('background').src = 'Default.png';
		document.getElementById('edge').src = 'Edge.png';
		document.getElementById('backBackground').src = 'Back.png';
		document.body.className = '';
		window.resizeTo(250,100);
	}
}

function openSite (theUrl) {

	theResult = true;
	if (window.widget) {
		widget.openURL(theUrl);
		theResult = false;
	}
	return theResult;

}

// Hide and Show Preferences

function showPrefs () {

	if (window.widget) widget.prepareForTransition('ToBack'); // freeze the widget
	document.getElementById('front').style.display='none'; // hide the front
	document.getElementById('back').style.display='block'; // show the back
	if (window.widget) setTimeout ('widget.performTransition();', 0); // flip the widget over	
	document.getElementById('fliprollie').style.display = 'none'; // hide the circle behind the info button

}

function hidePrefs() {

	if (window.widget) {
		var oldOrderno = (widget.preferenceForKey('orderno'+widget.identifier)) ? 
			widget.preferenceForKey('orderno'+widget.identifier) : '';
		var oldZipcode = (widget.preferenceForKey('zipcode'+widget.identifier)) ? 
			widget.preferenceForKey('zipcode'+widget.identifier) : '';
		widget.setPreferenceForKey(orderno.value,'orderno'+widget.identifier);
		widget.setPreferenceForKey(zipcode.value,'zipcode'+widget.identifier);
		widget.setPreferenceForKey(updateevery.value,'updateevery'+widget.identifier);
		widget.setPreferenceForKey(widgetsize.value,'widgetsize'+widget.identifier);
	}
	if (updateevery.value) theInterval = parseInt(updateevery.value);
	toggleSize();

	if (window.widget) widget.prepareForTransition('ToFront'); // freeze the widget
	document.getElementById('back').style.display='none'; // hide the back
	document.getElementById('front').style.display='block'; // show the front
	if (window.widget) setTimeout ('widget.performTransition();', 0); // flip back

	if (oldOrderno != orderno.value || oldZipcode != zipcode.value) {
		resetItemList();
		updateStatus(true);
	} else updateStatus(false);

}

// Preference Button Animation

var flipShown = false; // a flag used to signify if the flipper is currently shown or not.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event) {
	if (!flipShown) { // if the preferences flipper is not already showing...
		if (animation.timer != null) { // reset the animation timer value, in case a value was left behind
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13; 					// set it back one frame
		animation.duration = 500;									// animation time, in ms
		animation.starttime = starttime;							// specify the start time
		animation.firstElement = document.getElementById ('flip');	// specify the element to fade
		animation.timer = setInterval ('animate();', 13);			// set the animation function
		animation.from = animation.now;								// beginning opacity
		animation.to = 1.0;											// final opacity
		animate();													// begin animation
		flipShown = true;											// mark the flipper as animated
	}
}

function mouseexit (event) {
	if (flipShown) {
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ('animate();', 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	T = limit_3(time-animation.starttime, 0, animation.duration);	
	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	} else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}
function enterflip(event) {
	document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event) {
	document.getElementById('fliprollie').style.display = 'none';
}